#include "analyse_alti.h" 

/*---------------------------------*/

/* Prototypes for Tides_function.c */

/*---------------------------------*/

extern double nodal_factort(int formula,astro_ang_struct *astro_ang);


extern void astronomic_angle(double tj, int verbose, astro_ang_struct *astro_ang);


extern void init_argument(double first_time, int verbose, int CTO,astro_ang_struct *astro_ang);


extern int julian_day(int mm,int id,int iyyy);
 

extern void tide_wavearray_initC(wavelist *spectrum_list, int nwave);


extern double pulsation( tidal_wave wave);


extern double greenwhich_argument(tidal_wave w,astro_ang_struct *astro_ang);


extern double nodal_phase(tidal_wave w,astro_ang_struct *astro_ang);


extern void harmonic_analysis(double *sealevel,double *time, int n,
		wavelist s,int nopt, double lon, double lat, 
		fcomplex *tabZ_sortie, double *h, int *KEEP,int CTO);


extern double Tide_prediction(double time,tidal_wave wave,fcomplex Z,int verbose,int CTO);


extern void tidal_potential(tidal_wave wave,double lat,double lon,
		 double *Amp, double *G,int terrestre);


extern void orthotide_analysis(double *sealevel,double *time, 
		int n,wavelist s,int nopt, double lon, double lat,
		 fcomplex *tabZ_sortie, int CTO);


extern void mixte_analysis(int nmes,double *sealevel,double *time,
		wavelist s, fcomplex *tabZ_sortie, int *KEEP,
		typeA typ, int nb_group, int CTO);


extern void calendary(int njd,date_t *actual);


extern void getcnesdate(double t,date_t *actual);


extern void harmonic_analysis_parra(double *sealevel,double *time, int n,
		wavelist s,int nopt, double lon, double lat, 
		fcomplex *tabZ_sortie, double *h, int *KEEP,int CTO,int CPU);

extern void * calcul_cos_sin(void *input);


extern void * calcul_A(void *input);
/*parra*/

/*---------------------------------*/

/* Prototypes for bmg.c */

/*---------------------------------*/

extern int bmg_readheader (FILE *in,bmg_fheader *header);


extern int bmg_saver1 (char* file, int k, int d, int t, grid2_t grid, float *buf);


extern int bmg_writeheader (FILE *in,bmg_fheader header);


extern int bmg_createheader_r (char* file,int kmax,int dmax,int tmax,
		grid2_t grid,float *levels,float mask);


extern void bmg_loadc1_analyse_alti (char* filename, int k,int d,int t,
		grid_t *grid, int *n, fcomplex **buffer, fcomplex *mask, int *status);

extern int bmg_savec1 (char* filename,int kmax,grid_t grid,int n,fcomplex *buf,float *levels,fcomplex mask);
		  
		  
/*---------------------------------*/

/* Prototypes for check.c */

/*---------------------------------*/

 
extern void checkspectrum (wavelist spectrum_list,wavelist *work_s_sortie,
		double Trepet,double trecord, int nopt,int *KEEP,FILE *checkfile);


extern void check_ortho (wavelist spectrum_list,wavelist *work_s_sortie,
		double Trepet,double trecord, int nopt,int *KEEP,FILE *checkfile);


extern int check_mixte_option(wavelist mixtelist,wavelist *mixtesortie,
		double Trepet,double trecord, int nopt,int *KEEP,typeA typ);


extern int geo_filter(double lat,double lon,double *XY,int test);


extern int eraser(int ratio,int *a,int *b);


extern int bassin_filter(double lat,double lon,char *filename);

extern int test_interior(poly,double,double, int *);


/*---------------------------------*/

/* Prototypes for ecmwf.c */

/*---------------------------------*/

extern short shswap( short shrtint );


extern int lswap( int long_word );


extern float fswap( float long_word );


extern double dswap2( double dword );


extern grid_t gswap( grid_t grid);


extern grid2_t g2swap( grid2_t grid);


extern int long_swap( int long_word );


extern int long_swapf( int *long_word);


extern float float_swap( float long_word );


extern float float_swapf( float *long_word);


extern short bswap( short shrtint );


extern fcomplex complex_swap(fcomplex z );


extern double dswap( double dword );


extern grid_t gridswap( grid_t grid);


extern double map_getf_xyt(grid_t grid, float *buf1, 
		float *buf2, double t1, double t2, float mask, 
		double x, double y, double t);


extern void read_header(double t, grid_t *grid, 
		int *sampling,  float *spec, int verbose);


extern int read_meteo(double t, int nx, int ny, float *buf1, int sampling);



/*---------------------------------*/

/* Prototypes for loading.c */

/*---------------------------------*/

extern void question(char inifilename[60],conf_struct *conf);


extern int WaveSetHBuffer(char *name, char *h_models, char *ext, 
		int longperiod,grid_t *grid_OT, fcomplex **buffer_OT, fcomplex *mask_OT);


extern void loadingEC(char *input,double lat, double lon,
		 fcomplex *Z,fcomplex *mask);


extern int Wave_select(int i, tidal_wave *carac,int detided);


extern int load_serie(double *time, double *sealevel, 
		double *lon, double *lat,FILE *fic_data,int heure);


extern int header(FILE *fic_data);


extern int questionmixte(int *position , wavelist S, typeA *t , wavelist *n);

extern int read_hawaii(FILE *hawaii,double *lat,double *lon,
		double *time,double *sealevel,date_t firstdate,int n);


extern void Path4Model(int i,char *path,char *ext);



/*---------------------------------*/

/* Prototypes for output.c */

/*---------------------------------*/

extern  void ERROR(int nopt,int nmes,int nbond,double lat,
		double lon,FILE *error);


extern void sortie_MGR(double lat, double lon, wavelist work_s,
 		float *amplitude, float *retard,FILE *mgrfile, char form, 
 		double Trepet, int numstation, char *stationname,int startyear,
		 int endyear,double trecord, char *version);



extern void sortieIOS_std(char form, int nopt,int nmes,double lat,
		double lon,wavelist work_s,float *amplitude,float *retard,
		FILE *IOS,char *stationname,int numstation,double t0,
		double t1,double t2,double rms1,double rms2,double mean);



extern void sortie_BAR(char form, int nopt,int nmes,double lat,
		double lon,wavelist work_s,float *amplitude,float *retard,FILE *BAR,
		char *stationname,int numstation,double t0,double t1,double t2,
		double rms1,double rms2,double mean,double *noise);



extern int diffmodel(double lat, double lon, fcomplex *tabZ_deti,
		 FILE **ecart,int nopt, int nmes, double *Delta,int i ,
 		wavelist work_s,int *ultro,char *gpath);


extern void save_hawaii(FILE *hawaii,double lat,double lon,
		double *residual,double *time,int numstation,
		char *stationname,date_t firstdate,int nmes,double t1);


extern void  hawaii_write_header(char *strcode, int year,
		double lat,double lon, FILE *hawaii);


extern int  hawaii_write_data(char *strcode,double time, 
		double *data,double mask , FILE *hawaii,double lat,
		double lon,int refyear);


extern void list_save_serie(int pos, double lon, double lat, 
		int nopt, FILE *out,int n,double *time, double *sealevel);



/*---------------------------------*/

/* Prototypes for system.c */

/*---------------------------------*/

extern void interactive(conf_struct *conf);

extern int alloc_copy(int nmes, double **pointeur);

extern void quit(char *message);

/*---------------------------------*/

/* Prototypes for tools.c */

/*---------------------------------*/

extern float module(fcomplex Z); 

extern float phase(fcomplex Z);

extern int map_interpolationc(grid_t grid,int n, fcomplex *buf, 
		fcomplex mask, float x, float y, fcomplex *z);

extern int force_interpolationc(grid_t grid,int n, fcomplex *buf, 
		fcomplex mask, float x, float y, fcomplex *z);

extern void found_z(int na,grid_t grid,double lat,double lon, 
		fcomplex *buffer,fcomplex mask,fcomplex *z);
	
extern int unmask (double *time,double *sealevel,int nmes,double mask);

extern double trend_compute(double *sealevelcopy, double *time, int nmes);

extern void chi_square_limits(int nu,double *chi_inf,double *chi_sup);

extern void FFT_compute(double *residual, double *time, int nmes, 
	double Trepet, char *rpath, char *stationname,wavelist work_s,double *noiselevel) ;

extern int interpolate_tz(double *h, double *t, double mask, int n, double time, double *z);

extern int resample(double sampling,double *h, double *t, int nmes,double mask);
