#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <strings.h>
#include <malloc.h>  
#include <alloca.h>

#include "analyse_alti.h"
#include "aktarus.h"


/*list:
- void checkspectrum (wavelist spectrum_list,wavelist *work_s_sortie,double Trepet,double trecord, int nopt,int *KEEP,FILE *checkfile)
- void check_ortho (wavelist spectrum_list,wavelist *work_s_sortie,double Trepet,double trecord, int nopt,int *KEEP,FILE *checkfile)
- int check_mixte_option(wavelist mixtelist,wavelist *mixtesortie,double Trepet,double trecord, int nopt,int *KEEP,typeA typ)
- void FFT_compute(double *residual, double *time,  int nmes, double Trepet, double *sealevelcopy) 
- double trend_compute(double *sealevelcopy, double *time, int nmes)
- int geo_filter(double lat,double lon,double *XY,int test)
- eraser ###############################"
- int bassin_filter(double lat,double lon,char *filename)
- int test_interior(poly plg_polygones,double lon,double lat)
*/

/*-----------------------------------------------------------------------*/

void checkspectrum (wavelist spectrum_list,wavelist *work_s_sortie,double Trepet,double trecord, int nopt,int *KEEP,FILE *checkfile)

/*-----------------------------------------------------------------------*/

{
  int i,j,cpt,tmp,cst;
  int a,b;
  int *TMPKEEP;
  int ratio,status; 

  double *alias,deltaperiode; /* alias: periode aliasee en jours*/

  float w; /* weight on the Rayleigh criterion*/

  char rpt[52];

  wavelist work_s;

  /*  initialisation */

  /*attention work_s ici est local*/
  /*work_s_sortie correspond au work_s de topex_trXXX.c*/
  work_s.wave=(tidal_wave *)malloc(spectrum_list.n*sizeof(tidal_wave)); 
  alias=(double *)malloc(spectrum_list.n*sizeof(double));
  TMPKEEP=(int *)malloc(spectrum_list.n*sizeof(int));

  for (i=0;i<spectrum_list.n;i++) KEEP[i]=1;

  /*-----------------------------------------------------------------------*/
  /* 1/ Elimination des ondes de meme frequence                            */
  /*-----------------------------------------------------------------------*/

/*   fprintf(checkfile,"- Elimination of redundant frequencies (same frequencies)\n"); */
/*   fprintf(checkfile,"---------------------------------------------------------\n"); */
/*   fprintf(checkfile,"\n"); */
  
/*   cpt=0; */
/*   for (i=0;i<spectrum_list.n;i++) */
/*     { */
/*       for (j=i+1;j<spectrum_list.n;j++) */
/* 	{ */
/* 	  if (spectrum_list.wave[i].omega == spectrum_list.wave[j].omega) */
/* 	    { */
/* 	      cpt++; */
/* 	      KEEP[j]=0; */
/* 	    }		 */
/* 	}/* end for j*/   
/*     } /* end for i*/  
  
/*   i=0; */
/*   cst=0; */
/*   while ((i+cst)<spectrum_list.n) */
/*     {    */
/*       if (KEEP[i+cst])  */
/* 	{ */
/* 	  work_s.wave[i]=spectrum_list.wave[i+cst]; */
/* 	  i++; */
/* 	}   */
/*       else  */
/* 	{ */
/* 	  fprintf(checkfile,"wave %s discarded \n",spectrum_list.wave[i+cst].name); */
/* 	  cst++; */
/* 	} */

/*     }/*while*/   
/*   work_s.n=spectrum_list.n-cst; */


/* working spectrum work_s definition */
  for (i=0;i<spectrum_list.n;i++) work_s.wave[i]=spectrum_list.wave[i];
  work_s.n=spectrum_list.n; 
	



  /*-----------------------------------------------------------------------*/
  /* 2/     Test sur l'alias de l'onde   				   */
  /*   si T < 2* repetitivite => alias = T aliasee [jours]                 */
  /*   sinon                  => alias = T ondes [jours]                   */
  /*-----------------------------------------------------------------------*/

  i=0;

  while (i<work_s.n)
    {
      if (360/work_s.wave[i].omega < 2*Trepet*24)   /* comparaison periodes en heures*/
	{
	  alias[i]= Trepet/ fabs(work_s.wave[i].omega/360*Trepet*24 
				 - floor(work_s.wave[i].omega/360*Trepet*24 +0.5)) ;
	}
      else alias[i]=360/work_s.wave[i].omega/24;
      i++;
    } /* end while*/




  /*-----------------------------------------------------------------------*/

  /* 3/ Application du critere de separation des ondes--> RAYLEIGH         */

  /*-----------------------------------------------------------------------*/

  fprintf(checkfile,"\n");
  fprintf(checkfile," -Checking non-separable frequencies (Rayleigh criterion)\n");
  fprintf(checkfile,"--------------------------------------------------------\n");
  fprintf(checkfile,"\n");

  for (i=0;i<work_s.n;i++) KEEP[i]=2; /* all waves analysed a priori */
	
  cpt=0;
  for (i=0; i<work_s.n;i++)
    {
      for (j=i+1;j<work_s.n;j++)
	{
	  deltaperiode=alias[i]-alias[j];
	  if( !(1/alias[j]) ) KEEP[j]=0;
	  if( !(1/alias[i]) ) KEEP[i]=0;


	  if(trecord>365) w=1.0;
	  else w=0.85; 

	  if (trecord < w*fabs(alias[i]*alias[j]/ deltaperiode) )
	    {
	      /* admittance */
	      cpt++;
	      a=work_s.wave[i].code;
	      b=work_s.wave[j].code; 
	      ratio=a*100+b;   

	      status=eraser(ratio,&a,&b);
	      if(status) printf("warning suspiscious separation for %s and %s\n",work_s.wave[i].name,work_s.wave[j].name);

	      if (a<KEEP[i]) KEEP[i]=a;
	      if (b<KEEP[j]) KEEP[j]=b;

	    } /* if trecord...*/	 
	} /*for j*/ 
    } /* for i*/ 
	

  if (cpt==0) fprintf(checkfile,"\nall waves separable following this criterion \n");


  for(i=0;i<work_s.n;i++) TMPKEEP[i]=KEEP[i];

  i=0;
  cst=0;
  while ((i+cst)<work_s.n)
    {   
      if (TMPKEEP[i+cst]>0) 
	{
	  KEEP[i]=TMPKEEP[i+cst];
	  work_s_sortie->wave[i]=work_s.wave[i+cst];
	  i++;
	}  
      else 
	{
	  fprintf(checkfile,"\n%s tidal wave eliminated \n",work_s.wave[i+cst].name); 
	  cst++;
	}

    }/*while((i+cst)<work_s.n)*/  
  tmp=work_s.n-cst;

  work_s_sortie->n=tmp;
 

  free(alias);
  free(work_s.wave);
  free(TMPKEEP);

}/*end*/



   
/*-----------------------------------------------------------------------*/
void check_ortho (wavelist spectrum_list,wavelist *work_s_sortie,double Trepet,double trecord, int nopt,int *KEEP,FILE *checkfile)

     /*-----------------------------------------------------------------------*/

{
  int i,j,cpt,tmp,cst;
  int a,b;
  int *TMPKEEP;
  char rpt[52];
  wavelist work_s;
  double *alias,deltaperiode; /* alias: periode aliasee en jours*/
  int ratio; 
  /*  initialisation */ 

  work_s.wave=(tidal_wave *)malloc(spectrum_list.n*sizeof(tidal_wave));
  alias=(double *)malloc(spectrum_list.n*sizeof(double));
  TMPKEEP=(int *)malloc(spectrum_list.n*sizeof(int));

  for (i=0;i<spectrum_list.n;i++)
    {
      KEEP[i]=1;
    }

  /*-----------------------------------------------------------------------*/
  /* 1/ Elimination des ondes de meme frequence                            */
  /*-----------------------------------------------------------------------*/
  fprintf(checkfile,"- Elimination of redundant frequencies (same frequencies)\n");
  fprintf(checkfile,"---------------------------------------------------------\n");
  fprintf(checkfile,"\n");

  cpt=0;
  for (i=0;i<spectrum_list.n;i++)
    {
      for (j=i+1;j<spectrum_list.n;j++)
	{
	  if (spectrum_list.wave[i].omega == spectrum_list.wave[j].omega)
	    {
	      cpt++;
	      KEEP[j]=0;
	    }		
	}/* end for j*/ 
    } /* end for i*/ 
		
  i=0;
  cst=0; 
  while ((i+cst)<spectrum_list.n)
    {   
      if (KEEP[i+cst]) 
	{
	  work_s.wave[i]=spectrum_list.wave[i+cst];
	  i++;
	}  
      else 
	{
	  fprintf(checkfile,"\nwave %s discarded \n",spectrum_list.wave[i+cst].name);
	  cst++;
	}

    }/*while*/ 
  work_s.n=spectrum_list.n-cst;


  if (cpt==0)
    {	
      fprintf(checkfile,"\n0 wave eliminated following this criterion \n");
    }
	
  /*-----------------------------------------------------------------------*/
  /* 2/     Test sur l'alias de l'onde   					 */
  /*   si T < 2* repetitivite => alias = T aliasee [jours]                */
  /*   sinon                  => alias = T ondes [jours]                  */
  /*-----------------------------------------------------------------------*/

  i=0;

  while (i<work_s.n)
    {
      if (360/work_s.wave[i].omega < 2*Trepet*24)   /* comparaison periodes en heures*/
	{
	  alias[i]= Trepet/ fabs(work_s.wave[i].omega/360*Trepet*24 
				 - floor(work_s.wave[i].omega/360*Trepet*24 +0.5)) ;
	}
      else alias[i]=360/work_s.wave[i].omega/24;
      i++;
    } /* end while*/

  /*-----------------------------------------------------------------------*/
  /* 3/Elimination systematique des ondes non lineaires            	 */
  /*-----------------------------------------------------------------------*/

  fprintf(checkfile,"\n");
  fprintf(checkfile," -Elimination of non linear waves from the spectrum\n");
  fprintf(checkfile,"---------------------------------------------------\n");
  fprintf(checkfile,"\n");
	
  for (i=0; i<work_s.n;i++)
    {
      if (work_s.wave[i].spec=='p')  KEEP[i]=1;
      else KEEP[i]=0;
    }

  for(i=0;i<work_s.n;i++) TMPKEEP[i]=KEEP[i];

  i=0;
  cst=0;
  while ((i+cst)<work_s.n)
    {   
      if (TMPKEEP[i+cst]>0) 
	{
	  KEEP[i]=TMPKEEP[i+cst];
	  work_s_sortie->wave[i]=work_s.wave[i+cst];
	  i++;
	}  
      else 
	{
	  fprintf(checkfile,"%s tidal wave eliminated \n",work_s.wave[i+cst].name); 
	  cst++;
	}

    }/*while((i+cst)<work_s.n)*/  
  tmp=work_s.n-cst;

  work_s_sortie->n=tmp;
 
  free(alias);
  free(work_s.wave);
  free(TMPKEEP);

}/*end*/


/*-----------------------------------------------------------------------*/

int check_mixte_option(wavelist mixtelist,wavelist *mixtesortie,double Trepet,double trecord, int nopt,int *KEEP,typeA typ)

/*-----------------------------------------------------------------------*/
{

  int i,j,ok;
  int a,b,tmp;
  int cpt,cst,status;
  float ratio;
  double  *alias;
  double deltaperiode;
  int *TMPKEEP;

  i=0;
  TMPKEEP=(int *)malloc(mixtelist.n*sizeof(int));
  alias=(double *)malloc(mixtelist.n*sizeof(double));

  while (i<typ.h)
    {
      if (360/mixtelist.wave[i].omega < 2*Trepet*24)   /* comparaison periodes en heures*/
	{
	  alias[i]= Trepet/ fabs(mixtelist.wave[i].omega/360*Trepet*24 
				 - floor(mixtelist.wave[i].omega/360*Trepet*24 +0.5)) ;
	}
      else alias[i]=360/mixtelist.wave[i].omega/24;
      i++;
    } /* end while*/

  /*-----------------------------------------------------------------------*/
  /* 3/ Application du critere de separation des ondes--> RAYLEIGH  	 */
  /*-----------------------------------------------------------------------*/

  for (i=0;i<mixtelist.n;i++)
    {
      KEEP[i]=2; 
    }
	
  cpt=0;
  for (i=0; i<typ.h;i++)
    {
      for (j=i+1;j<typ.h;j++)
	{
	  deltaperiode=alias[i]-alias[j];
	  if(!(1/alias[j])) KEEP[j]=0;
	  if(!(1/alias[i])) KEEP[i]=0;

	  if (trecord < fabs (alias[i]*alias[j]/ deltaperiode) )
	    {
	      /* admittance */
	      cpt++;
	      a=mixtelist.wave[i].code;
	      b=mixtelist.wave[j].code; 
	      ratio=a*100+b;
	      status=eraser(ratio,&a,&b);

	      if (a<KEEP[i]) KEEP[i]=a;
	      if (b<KEEP[j]) KEEP[j]=b;

	    } /* if trecord...*/	 
	} /*for j*/ 
    } /* for i*/ 
	


  for(i=0;i<mixtelist.n;i++)
    if (KEEP[i]==1)
      {
	ok=0;
	for(j=0;j<typ.h;j++) if (mixtelist.wave[i].admit==mixtelist.wave[i].code) ok=1;
	if (ok==0)KEEP[i]=0;
      }

       

     




  for(i=0;i<mixtelist.n;i++) TMPKEEP[i]=KEEP[i];

  i=0;
  cst=0;
  while ((i+cst)<mixtelist.n)
    {   
      if (TMPKEEP[i+cst]>0) 
	{
	  KEEP[i]=TMPKEEP[i+cst];
	  mixtesortie->wave[i]=mixtelist.wave[i+cst];
	  i++;
	}  
      else 
	{
	  cst++;
	}

    }/*while((i+cst)<mixtelist.n)*/  
  tmp=mixtelist.n-cst;

  mixtesortie->n=tmp;
 



  free(alias);
  free(TMPKEEP);
  return(typ.h-cst);

}/*end*/




/*---------------------------------------------------------------------------*/

int geo_filter(double lat,double lon,double *XY,int test)

/*---------------------------------------------------------------------------*/
{
  int filtre=0;
  

  if ((XY[2]<0) && (lon>180)) lon-=360;

  if (test) if ( (lat>XY[0]) && (lat<XY[1]) &&  (lon<XY[3]) && (lon>XY[2]) ) filtre=1;
  else filtre =0;

  else      if ( (lat>-91) && (lat<91) ) filtre=1;
  else filtre =0;


  if ((XY[2]<0) && (lon>180)) lon+=360;

  return(filtre);
}
 

/*---------------------------------------------------------------------------*/

int eraser(int ratio,int *a,int *b)

/*---------------------------------------------------------------------------*/
{
  int status=0;


  switch(ratio)
    {
      /* -----------------------------------------------------------------------------*/
      
      /* 1) admittance*/
      
      /* -----------------------------------------------------------------------------*/



      /*------------analyse/admittance--------------*/

      /*----------------K2/P1------------------------*/
    case 1402 : {*a=2;*b=1;printf("K2 analysed, P1 deduced by admittance on K1\n");break;};
    case 214 :  {*a=1;*b=2;printf("K2 analysed, P1 deduced by admittance on K1\n");break;};

      /*----------------K1/P1------------------------*/
    case 302  : {*a=2;*b=1;printf("K1 analysed, P1 deduced by admittance on K1\n");break;};
    case 203  : {*a=1;*b=2;printf("K1 analysed, P1 deduced by admittance on K1\n");break;};

      /*---------------N2/T2------------------------*/
    case 712  : {*a=2;*b=1;printf("N2 analysed, T2 deduced by admittance on K2\n");break;};
    case 1207 : {*a=1;*b=2;printf("N2 analysed, T2 deduced by admittance on K2\n");break;};

      /*--------------M2/NU2------------------------*/
    case 908 : {*a=2;*b=1;printf("M2 analysed, Nu2 deduced by admittance on N2\n");break;};
    case 809 : {*a=1;*b=2;printf("M2 analysed, Nu2 deduced by admittance on N2\n");break;};

      /*-------------L2/Mu2------------------------*/
    case 611 :  {*a=2;*b=1;printf("L2 analysed, Mu2 deduced by admittance on 2N2\n");break;};
    case 1106 : {*a=1;*b=2;printf("L2 analysed, Mu2 deduced by admittance on 2N2\n");break;};

      /*-------------Q1/Nu2------------------------*/
    case 2708 : {*a=2;*b=1;printf("Q1 analysed, Nu2 deduced by admittance on N2\n");break;};
    case 827  : {*a=1;*b=2;printf("Q1 analysed, Nu2 deduced by admittance on N2\n");break;};

      /*-------------L2/T2------------------------*/
    case 1112 : {*a=2;*b=1;printf("L2 analysed, T2 deduced by admittance on K2\n");break;};
    case 1211 : {*a=1;*b=2;printf("L2 analysed, T2 deduced by admittance on K2\n");break;};

      /*-------------S2/K2------------------------*/
    case 1314  : {*a=2;*b=1;printf("S2 analysed, K2 deduced by admittance on S2\n");break;};
    case 1413  : {*a=1;*b=2;printf("S2 analysed, K2 deduced by admittance on S2\n");break;};
 
     /*-------------S2/R2------------------------*/
    case 1350  : {*a=2;*b=1;printf("S2 analysed, R2 deduced by admittance on K2\n");break;};
    case 5013  : {*a=1;*b=2;printf("S2 analysed, R2 deduced by admittance on K2\n");break;};
 
     /*-------------S2/T2------------------------*/
    case 1312  : {*a=2;*b=1;printf("S2 analysed, T2 deduced by admittance on K2\n");break;};
    case 1213  : {*a=1;*b=2;printf("S2 analysed, T2 deduced by admittance on K2\n");break;};

      /*-------------MNS2/E2------------------------*/
    case 1014 : {*a=2;*b=1;printf("MNS2 analysed, E2 deduced by admittance on 2N2\n");break;};
    case 501  : {*a=1;*b=2;printf("MNS2 analysed, E2 deduced by admittance on 2N2\n");break;};

      /*-------------Mtm/S1------------------------*/
/*     case 4226 : {*a=2;*b=1;printf("Mtm analysed, S1 deduced by admittance on K1\n");break;}; */
/*     case 2642 : {*a=1;*b=2;printf("Mtm analysed, S1 deduced by admittance on K1\n");break;}; */

      /*-------------OO1/Msf------------------------*/
    case 2839 : {*a=2;*b=1;printf("OO1 analysed, Msf deduced by admittance on Mf\n");break;};
    case 3928 : {*a=1;*b=2;printf("OO1 analysed, Msf deduced by admittance on Mf\n");break;};

      /*-------------3MS8/Msm------------------------*/
    case 6141 : {*a=2;*b=1;printf("3MS8 analysed, Msm deduced by admittance on Mm\n");break;};
    case 4161 : {*a=1;*b=2;printf("3MS8 analysed, Msm deduced by admittance on Mm\n");break;};

      /*-------------MN4/Mstm------------------------*/
/*     case 1744 : {*a=2;*b=1;printf("MN4 analysed, Mstm deduced by admittance on Mtm\n");break;}; */
/*     case 4417 : {*a=1;*b=2;printf("MN4 analysed, Mstm deduced by admittance on Mtm\n");break;}; */

      /*-------------Sa/Psi1------------------------*/
    case 4700 : {*a=2;*b=1;printf("Sa analysed, Psi1 deduced by admittance on K1\n");break;};
    case 44 :   {*a=1;*b=2;printf("Sa analysed, Psi1 deduced by admittance on K1\n");break;};

      /*-------------Q1/R2------------------------*/
    case 2750 : {*a=2;*b=1;printf("Q1 analysed, R2 deduced by admittance on K2\n");break;};
    case 5027 : {*a=1;*b=2;printf("Q1 analysed, R2 deduced by admittance on K2\n");break;};

      /*-------------Pi1/R2------------------------*/
    case 7150 : {*a=2;*b=1;printf("Pi1 analysed, R2 deduced by admittance on K2\n");break;};
    case 5071 : {*a=1;*b=2;printf("Pi1 analysed, R2 deduced by admittance on K2\n");break;};

      /*-------------MSN2/T2------------------------*/
    case 1512 : {*a=2;*b=1;printf("MSN2 analysed, T2 deduced by admittance on K2\n");break;};
    case 1215 : {*a=1;*b=2;printf("MSN2 analysed, T2 deduced by admittance on K2\n");break;};

      /*-------------M6/L2------------------------*/
    case 2211 : {*a=2;*b=1;printf("M6 analysed, L2 deduced by admittance on K2\n");break;};
    case 1122 : {*a=1;*b=2;printf("M6 analysed, L2 deduced by admittance on K2\n");break;};


      /* -----------------------------------------------------------------------------*/

      /* 2) eject*/

      /* -----------------------------------------------------------------------------*/


      /*------------analyse/eject--------------*/

      /*-------------M4/OO1------------------------*/
    case 2818 : {*a=2;*b=0;printf("M4 analysed, OO1 discarded\n");break;};
    case 1828 : {*a=0;*b=2;printf("M4 analysed, OO1 discarded\n");break;};

      /*-------------MU2/M6------------------------*/
    case 622 : {*a=2;*b=0;printf("Mu2 analysed, M6 discarded\n");break;};
    case 2206 :{*a=0;*b=2;printf("Mu2 analysed, M6 discarded\n");break;};

      /*---------------M2/S2------------------------*/
    case 913 : {*a=2;*b=0;printf("M2 analysed, S2 discarded\n");break;};
    case 1309 :{*a=0;*b=2;printf("M2 analysed, S2 discarded\n");break;};

      /*---------------T2/M6------------------------*/
    case 1222 : {*a=2;*b=0;printf("T2 analysed, M6 discarded\n");break;};
    case 2212 : {*a=0;*b=2;printf("T2 analysed, M6 discarded\n");break;};

      /*---------------MSK2/OP2------------------------*/
    case 3200 : {*a=2;*b=0;printf("MKS2 analysed, OP2 discarded\n");break;};
    case 10031 :{*a=0;*b=2;printf("MKS2 analysed, OP2 discarded\n");break;};

      /*---------------Sa/KQ1------------------------*/
    case 4776 : {*a=2;*b=0;printf("Sa analysed, KQ1 discarded\n");break;};
    case 7647 : {*a=0;*b=2;printf("Sa analysed, KQ1 discarded\n");break;};

      /* -----------------------------------------------------------------------------*/

      /* 3) default */

      /* -----------------------------------------------------------------------------*/
    default: {status=1;*a=2;*b=2;}
      
    }

  return(status);

}/* end eraser */



/*---------------------------------------------------------------------------*/

int bassin_filter(double lat,double lon,char *filename)

/*---------------------------------------------------------------------------*/
{
  poly plg;
  int tmp,i,in;
  FILE *polyfile;
	  
  in=0;
  if( (polyfile=fopen(filename,"r"))==NULL) quit("can't find polygone description file");

  if(lon>180) lon-=360;

  do 
    {
      if ( fscanf(polyfile,"%d",&tmp) !=1 ) break;
      fscanf(polyfile,"%d",&plg.npoly);

      if((plg.x=malloc(plg.npoly*sizeof(double))) == NULL) quit("can't allocate polygone longitude");
      if((plg.y=malloc(plg.npoly*sizeof(double))) == NULL) quit("can't allocate polygone latitude");
    
      for(i=0;i<plg.npoly;i++) fscanf(polyfile,"%d %lf %lf",&tmp,&(plg.x[i]),&(plg.y[i]));
      tmp=test_interior(plg,lon,lat,&in);
      
      free(plg.x);
      free(plg.y);

    }while(!feof(polyfile));

  fclose(polyfile);

  return(tmp);
    

}/*end  bassin_filter*/


/*---------------------------------------------------------------------------*/

 int test_interior(poly plg,double lon,double lat,int *in)

/*---------------------------------------------------------------------------*/
{
  int isize,ipos;
  int k,l,ok=0;
  int plg_point_interior=1,plg_point_boundary=0,plg_point_exterior=-1;

  double *dx,*dy,*dn,*delta;
  double epsilon,error,tx,ty,ang,nx,ny,ux,uy,ix,iy,vx,vy;
  double alpha,beta;
 
  isize=plg.npoly;
  
  dx=malloc(isize*sizeof(double));
  dy=malloc(isize*sizeof(double));
  dn=malloc(isize*sizeof(double));
  delta=malloc(isize*sizeof(double));

  epsilon=1E-12;
  error=1E-04;
  nx=0;
  ny=0;
  tx=1.0;
  ty=0.0;

  ang=0.0;

  for(k=0;k<isize-1;k++)
    {
      dx[k]=plg.x[k+1]-plg.x[k];
      dy[k]=plg.y[k+1]-plg.y[k];
      dn[k]=sqrt(dx[k]*dx[k]+dy[k]*dy[k]);
      if((dx[k]==0)&&(dy[k]==0)) quit("erreur de polygone\n");   
    }
  nx=-ty;
  ny=+tx;
	   
  for(l=0;l<isize-1;l++)
    {
      delta[l]=nx*dx[l]+ny*dy[l];
/*       if ((delta[l]<error)&&(delta[l]>-error) ) */
      if (fabs(delta[l]) < error*dn[l])
	{
	  ang=ang+0.001;
	  tx=cos(ang);
	  ty=sin(ang);
	  nx=-ty;
	  ny=+tx;
	  l=0;
	}
    }
 
  for(l=0;l<isize-1;l++)
    {
      ux=lon-plg.x[l];
      uy=lat-plg.y[l];
      alpha=(nx*ux+ny*uy)/delta[l];

      if ((alpha >= 0.0)&&(alpha < 1.0)) 
	{
	  ix=plg.x[l]+alpha*dx[l];
	  iy=plg.y[l]+alpha*dy[l];
	  vx=ix-lon;
	  vy=iy-lat;
	  beta=vx*tx+vy*ty;
	  if(fabs(beta)<epsilon)
	    {
	      ipos=plg_point_boundary;
	      return(ipos);
	    }
	  if(beta>0) *in=(!(*in));
	}
     }


  
  if ((*in)==1) 
    ipos=plg_point_interior;
  else ipos=plg_point_exterior;

  
  free(dx);
  free(dy);
  free(delta);
  free(dn);

  return(ipos);


}/*end*/





