#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>  
#include <strings.h>
#include <malloc.h>

#include "analyse_alti.h"
#include "aktarus.h"

double meteo_step;
int    meteo_nvar=1;
char
meteo_rootname[256]="/data/nivmer/travail_en_cours/analyse_topex/DATA/PRESSION";

/*--------------- */
/* SWAP FUNCTIONS */
/*--------------- */

/*----------------------------------------------------------------------*/
short shswap( short shrtint )
/*----------------------------------------------------------------------*/
{
  union{
    short l;
    unsigned char byte[2];
  } into, outof;
  
  into.l = shrtint;
  outof.byte[0]=into.byte[1];
  outof.byte[1]=into.byte[0];
  return( outof.l );
}

/*----------------------------------------------------------------------*/
int lswap( int long_word )
/*----------------------------------------------------------------------*/
{
  union{
    int l;
    unsigned char byte[4];
  } inword, outword;
  
  inword.l=long_word;
  outword.byte[0] = inword.byte[3];
  outword.byte[1] = inword.byte[2];
  outword.byte[2] = inword.byte[1];
  outword.byte[3] = inword.byte[0];
  return( outword.l );
}


/*----------------------------------------------------------------------*/
float fswap( float long_word )
/*----------------------------------------------------------------------*/
{
  union{
    float l;
    unsigned char byte[4];
  } inword, outword;
  
  inword.l=long_word;
  outword.byte[0] = inword.byte[3];
  outword.byte[1] = inword.byte[2];
  outword.byte[2] = inword.byte[1];
  outword.byte[3] = inword.byte[0];
  return( outword.l );
}


/*------------------------------------------------------------------------
  
  Name        :  dswap
ATTENTION: dswap a ete renomme dswap2, sinon il y avait un pb avec dswap
definie dans kernel/
Cette fonction n'intervient que dans UserInOut(), ligne 184
--------------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
double dswap2( double dword )
/*----------------------------------------------------------------------*/
{
  union 
  {
    double d;
    unsigned char bytes[8];
  } inval, outval,test;
  
  inval.d = dword;

/* Earlier version, may be working with DEC and pgcc, but NOT with cc*/

  outval.bytes[0] = inval.bytes[7];
  outval.bytes[1] = inval.bytes[6];
  outval.bytes[2] = inval.bytes[5];
  outval.bytes[3] = inval.bytes[4];
  outval.bytes[4] = inval.bytes[3];
  outval.bytes[5] = inval.bytes[2];
  outval.bytes[6] = inval.bytes[1];
  outval.bytes[7] = inval.bytes[0];

  /* Version, may be working with cc, but not pgcc  */
/*
  outval.bytes[0] = inval.bytes[3];
  outval.bytes[1] = inval.bytes[2];
  outval.bytes[2] = inval.bytes[1];
  outval.bytes[3] = inval.bytes[0];
  outval.bytes[4] = inval.bytes[7];
  outval.bytes[5] = inval.bytes[6];
  outval.bytes[6] = inval.bytes[5];
  outval.bytes[7] = inval.bytes[4];
*/


/*
  printf("%d,%d,%d,%d,%d,%d,%d,%d \n",outval.bytes[0],outval.bytes[1],
                                      outval.bytes[2],outval.bytes[3],
                                      outval.bytes[4],outval.bytes[5],
                                      outval.bytes[6],outval.bytes[7]);

  test.d=1.0;
  printf("%d,%d,%d,%d,%d,%d,%d,%d \n",test.bytes[0],test.bytes[1],
                                      test.bytes[2],test.bytes[3],
                                      test.bytes[4],test.bytes[5],
                                      test.bytes[6],test.bytes[7]);

*/  

  return( outval.d );
}



/*----------------------------------------------------------------------*/
grid_t gswap( grid_t grid)
/*----------------------------------------------------------------------*/
{
  grid_t tmp;

  tmp.nx=lswap(grid.nx);
  tmp.ny=lswap(grid.ny);
  tmp.Mode=lswap(grid.Mode);
  tmp.xmin=fswap(grid.xmin);
  tmp.ymin=fswap(grid.ymin);
  tmp.xmax=fswap(grid.xmax);
  tmp.ymax=fswap(grid.ymax);
  tmp.dx=fswap(grid.dx);
  tmp.dy=fswap(grid.dy);

  return( tmp );
}

/*----------------------------------------------------------------------*/
grid2_t g2swap( grid2_t grid)
/*----------------------------------------------------------------------*/
{
  grid2_t tmp;

  tmp.nx=lswap(grid.nx);
  tmp.ny=lswap(grid.ny);
  tmp.Mode=lswap(grid.Mode);
  tmp.xmin=fswap(grid.xmin);
  tmp.ymin=fswap(grid.ymin);
  tmp.xmax=fswap(grid.xmax);
  tmp.ymax=fswap(grid.ymax);
  tmp.dx=fswap(grid.dx);
  tmp.dy=fswap(grid.dy);

  return( tmp );
}

/*----------------------------------------------------------------------*/
int long_swap( int long_word )
/*----------------------------------------------------------------------*/
{
  union{
    int l;
    unsigned char byte[4];
  } inword, outword;
  
  inword.l=long_word;
  outword.byte[0] = inword.byte[3];
  outword.byte[1] = inword.byte[2];
  outword.byte[2] = inword.byte[1];
  outword.byte[3] = inword.byte[0];
  return( outword.l );
}

/*----------------------------------------------------------------------*/
int long_swapf( int *long_word)
/*----------------------------------------------------------------------*/
{
  int result;
  result=long_swap(*long_word);
  /* printf("int: %d \n\n",result); */
  return(result);
}

/*----------------------------------------------------------------------*/
float float_swap( float long_word )
/*----------------------------------------------------------------------*/
{
  union{
    float l;
    unsigned char byte[4];
  } inword, outword;
  
  inword.l=long_word;
  outword.byte[0] = inword.byte[3];
  outword.byte[1] = inword.byte[2];
  outword.byte[2] = inword.byte[1];
  outword.byte[3] = inword.byte[0];
  return( outword.l );
}

/*----------------------------------------------------------------------*/
float float_swapf( float *long_word)
/*----------------------------------------------------------------------*/
{
  float result;
  result=float_swap(*long_word);
  /*  printf("flt: %f \n",result);*/
  return(result);
}


/*----------------------------------------------------------------------*/
short bswap( short shrtint )
/*----------------------------------------------------------------------*/
{
  union{
    short l;
    unsigned char byte[2];
  } into, outof;
  
  into.l = shrtint;
  outof.byte[0]=into.byte[1];
  outof.byte[1]=into.byte[0];
  return( outof.l );
}

/*----------------------------------------------------------------------*/
fcomplex complex_swap(fcomplex z )
/*----------------------------------------------------------------------*/
{
  union 
  {
    fcomplex c;
    unsigned char bytes[8];
  } inval, outval;
  
  inval.c = z;

  outval.bytes[0] = inval.bytes[3];
  outval.bytes[1] = inval.bytes[2];
  outval.bytes[2] = inval.bytes[1];
  outval.bytes[3] = inval.bytes[0];
  outval.bytes[4] = inval.bytes[7];
  outval.bytes[5] = inval.bytes[6];
  outval.bytes[6] = inval.bytes[5];
  outval.bytes[7] = inval.bytes[4];

  return( outval.c );
}

/*----------------------------------------------------------------------*/
double dswap( double dword )
/*----------------------------------------------------------------------*/
{
  union 
  {
    double d;
    unsigned char bytes[8];
  } inval, outval,test;
  
  inval.d = dword;
/* Earlier version, may be working with DEC and pgcc, but NOT with cc*/

  outval.bytes[0] = inval.bytes[7];
  outval.bytes[1] = inval.bytes[6];
  outval.bytes[2] = inval.bytes[5];
  outval.bytes[3] = inval.bytes[4];
  outval.bytes[4] = inval.bytes[3];
  outval.bytes[5] = inval.bytes[2];
  outval.bytes[6] = inval.bytes[1];
  outval.bytes[7] = inval.bytes[0];



  /* Version, may be working with cc, but not pgcc  */
/*
  outval.bytes[0] = inval.bytes[3];
  outval.bytes[1] = inval.bytes[2];
  outval.bytes[2] = inval.bytes[1];
  outval.bytes[3] = inval.bytes[0];
  outval.bytes[4] = inval.bytes[7];
  outval.bytes[5] = inval.bytes[6];
  outval.bytes[6] = inval.bytes[5];
  outval.bytes[7] = inval.bytes[4];
*/


/*
  printf("%d,%d,%d,%d,%d,%d,%d,%d \n",outval.bytes[0],outval.bytes[1],
                                      outval.bytes[2],outval.bytes[3],
                                      outval.bytes[4],outval.bytes[5],
                                      outval.bytes[6],outval.bytes[7]);

  test.d=1.0;
  printf("%d,%d,%d,%d,%d,%d,%d,%d \n",test.bytes[0],test.bytes[1],
                                      test.bytes[2],test.bytes[3],
                                      test.bytes[4],test.bytes[5],
                                      test.bytes[6],test.bytes[7]);

*/  
  return( outval.d );
}

/*----------------------------------------------------------------------*/
grid_t gridswap( grid_t grid)
/*----------------------------------------------------------------------*/
{
  grid_t tmp;

  tmp.nx=long_swap(grid.nx);

  return( tmp );
}
/*-----------------------------------------------------------------------------------------*/
double map_getf_xyt(grid_t grid, float *buf1, float *buf2, double t1, double t2, float mask,
                                double x, double y, double t)
/*-----------------------------------------------------------------------------------------*/
{
  int k,l,k0,l0;
  double w,r1,r2,s,teta;
  double xx,yy;
  double z1,z2,z;
  int   n;

  n=grid.nx;

  teta=(t-t1)/(t2-t1);
/*
  if(teta < 0.0)
  {
    z=mask;
    return (z);
  }

  if(teta > 1.0)
  {
    z=mask;
    return (z);
  }
*/
  if(x < grid.xmin)
    {
    z=mask;
    return (z);
    }
    
  if (x > grid.xmax)
    {
    z=mask;
    return (z);
    }
 
  if(y < grid.ymin)
    {
    z=mask;
    return (z);
    }
 
  if(y > grid.ymax)
    {
    z=mask;
    return (z);
    }

  k0= (int) ((x-grid.xmin)/grid.dx);
  l0= (int) ((y-grid.ymin)/grid.dy);
 
  z1=0.0;
  z2=0.0;
  w=0.0;

  for( k=k0; k <= k0+1; k++)
    {
    xx=grid.xmin+k*grid.dx;
    if (k < 0)       break;
    if (k > grid.nx-1) break;
    for( l=l0; l <= l0+1; l++)
      {
      yy=grid.ymin+l*grid.dy;
      if(l < 0)       break;
      if(l > grid.ny-1) break;
      s=(grid.dx-fabs(x-xx))*(grid.dy-fabs(y-yy));
      r1=buf1[k+n*l];
      r2=buf2[k+n*l];
      if (r1 != mask)
        {
        z1 +=r1*s;
        z2 +=r2*s;
        w=w+s;
        }
      }
    }

if (w > 0.0)
  {
  z1 /=w;
  z2 /=w;
  z=(1.-teta)*z1+teta*z2;
  }
else        
  z=mask;

return(z);

}

/*----------------------------------------------------------------------*/
void read_header(double t, grid_t *grid, int *sampling,  float *spec, int verbose)
/*----------------------------------------------------------------------*/
{
  /* average est une adresse (size_t) contenant l'adresse (*average) du futur tableau*/

  int   i,j,k,l,M;
  int   day,m,n1,n2,N,recordsize;
  int   nlevel;
  int   status,hour,nframe;
  float time/* *avg */;
  size_t nitems,size;
  char comment[256];
  grid2_t grid2;
  int old_version=0;
  date_t actual;
  char filename[256];
  FILE *in;

  getcnesdate(t,&actual);
  hour=floor(actual.second/3600.);
/*   hour=(hour/meteo_step)*meteo_step; */
/*   printf("read meteo at: %2d/%2d/%4d %2dh\n",actual.day,actual.month,actual.year,hour); */
  
/*--------- Build the meteo file name and open it ----------------------*/

/*   filename=(char *)malloc(strlen(meteo_rootname)+256); */
  
  sprintf(filename,"%s/catmp.%4d.hdr",meteo_rootname,actual.year);

/*   printf("opening forcing file: %s \n", filename); */
  in=fopen(filename, "rb");

  recordsize=256;
  nitems=fread(comment,recordsize,1,in);
  if(verbose) printf("%s\n",comment);
  nitems=fread(comment,recordsize,1,in);
  if(verbose)  printf("%s\n",comment);
  nitems=fread(comment,recordsize,1,in);
  if(verbose) printf("%s\n",comment);
  nitems=fread(comment,recordsize,1,in);
  if(verbose) printf("%s\n",comment);

  recordsize=sizeof(grid2_t);
  nitems=fread(&grid2,recordsize,1,in);
/*   printf("nitems=%d \n",nitems); */
#ifdef SWAPIO
  grid2=g2swap(grid2);
#endif
  grid->nx=grid2.nx;
  grid->ny=grid2.ny;
  grid->Mode=grid2.Mode;
  grid->xmin=grid2.xmin;
  grid->ymin=grid2.ymin;
  grid->xmax=grid2.xmax;
  grid->ymax=grid2.ymax;
  grid->dx=grid2.dx;
  grid->dy=grid2.dy;
  grid->xmax=(grid->nx-1)*grid->dx;
  grid->ymax=(grid->ny-1+grid->ymin)*grid->dy;
  
/*   printf("nx,ny: %d %d \n",grid->nx,grid->ny); */
/*   printf("dx,dy: %f %f \n",grid->dx,grid->dy); */
/*   printf("xmin,xmax: %f %f \n",grid->xmin,grid->xmax); */
/*   printf("ymin,ymax: %f %f \n",grid->ymin,grid->ymax); */

  recordsize=sizeof(int);
  nitems=fread((void *) sampling,recordsize,1,in);

  if((*sampling != 3) && (*sampling != 6) && (*sampling != 24)){old_version=1;*sampling=24;}/*on a lu spec*/
 

/*   /* In old version, sampling was not given, thus we just got spec*/ 
  if(!old_version) 
    { 
    recordsize=sizeof(float);
    nitems=fread((void *) spec,recordsize,1,in);
    }


 /*  recordsize=sizeof(int); */
/*   nitems=fread((void *) &M,recordsize,1,in); */
/*   recordsize=sizeof(int); */
/*   nitems=fread((void *) nframe,recordsize,1,in); */

/*   recordsize=*nframe*sizeof(float); */

/*   *avg=(float *) malloc(recordsize); */
/*   nitems=fread(*avg,recordsize,1,in); */

/*   /* In old version, nframe is taken from 0 (bug), thus we need to add 1 to get */
/*     the actual number of time frames*/ 
/*   if(old_version)  */
/*     {  */
/*     *nframe+=1; */
/*     *sampling =6; */
/*     } */

  fclose(in);
/*   free(avg); */
}

/*----------------------------------------------------------------------*/
int read_meteo(double t, int nx, int ny, float *buf1, int sampling)
/*----------------------------------------------------------------------*/
/*  Atmospheric pressure and wind from AM fields; load the field at or
  just before t
 ----------------------------------------------------------------------*/
{ 
  int   k,i,dum,hour,status;
  size_t size,nitems,check,offset;
  char dummy[4];
  date_t actual;
  short *tmp[4];
  long shift;
  char *filename;
  FILE *in;
  int shift_day;

  meteo_step=sampling;

  getcnesdate(t,&actual);
  hour=floor(actual.second/3600.);
/*   hour=(hour/meteo_step)*meteo_step; */
/*   printf("read meteo at: %2d/%2d/%4d %2dh\n",actual.day,actual.month,actual.year,hour); */
  
/*------------ Build the meteo file name and open it ----------------------*/

  filename=(char *)malloc(strlen(meteo_rootname)+256);
  
  sprintf(filename,"%s/catmp.%4d",meteo_rootname,actual.year);

/*   printf("opening forcing file: %s \n", filename); */
  in=fopen(filename, "rb");
  free(filename);
  
  if (in == NULL)
    {
    printf("cannot open forcing file: %s \n", filename);
    return(-1);
    }
  
  for(k=0;k<meteo_nvar;k++) tmp[k]=(short *)malloc(nx*ny*sizeof(short));

/*----------------------------------------------------------------------
  Read sea level pressure and surface winds 
  File units : P in Pascals 
  return units: P in mbar
----------------------------------------------------------------------*/

  size=nx*ny*sizeof(short);
  nitems=1;
  
  shift_day=julian_day(actual.month,actual.day,actual.year)-julian_day(1,1,actual.year);
  
  shift=size*meteo_nvar*((shift_day));

  status=fseek(in,shift,SEEK_SET);
  if(status !=0)
    {
    printf("error reading forcing file (shift): date :  %2d/%2d/%4d %2dh\n",actual.day,actual.month,actual.year,hour);
    fclose(in);
    return(-1);
    }
  for(k=0;k<meteo_nvar;k++)
    if ((check=fread(tmp[k], size, nitems,in)) ==0) 
      {
      printf("error reading forcing file (frame): date :  %2d/%2d/%4d %2dh\n",actual.day,actual.month,actual.year,hour);    
      fclose(in);
      return(-1);
      }

#ifdef SWAPIO
  for(k=0;k<meteo_nvar;k++) for (i=0;i<nx*ny;i++) tmp[k][i]=shswap(tmp[k][i]);
#endif
  
  for (i=0;i<nx*ny;i++) 
    {
    buf1[i]=(float) tmp[0][i]/100.;
    }

  for(k=0;k<meteo_nvar;k++) free(tmp[k]);

  fclose(in);

  return(1);
}

