#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <strings.h>
#include <malloc.h>  

#include "analyse_alti.h"
#include "aktarus.h"

/*------------------------------------------------------------------------------*/ 

void interactive(conf_struct *conf)

/*------------------------------------------------------------------------------*/
{
  char sys_day[12],sys_month[12],sys_date[12],sys_hour[12],sys_min[12],sys_sec[12],sys_met[12],sys_year[12],sys_carac[1024];
  FILE *sys_tmp;
  char *tmp,tmp2[300];
  char root_path[512],input[512];
  int n;

 sprintf(sys_carac,"date >.toto");
 system(sys_carac);

 sys_tmp=fopen(".toto","r");
 fscanf(sys_tmp,"%s %s %s %2s:%2s:%2s %s %s",sys_day,sys_month,sys_date,sys_hour,sys_min,sys_sec,sys_met,sys_year);
 fclose(sys_tmp);

 sprintf(sys_carac,"\\rm .toto");
 system(sys_carac);

 tmp=malloc(1024);  
 tmp=strrchr(conf->justfilename,'.');
 if(tmp!=NULL)
     n=strlen(conf->justfilename)-strlen(tmp);
 else n=strlen(conf->justfilename);
 strncpy(tmp2,conf->justfilename,n);
 tmp2[n]='\0';

 sprintf(root_path,"%s_%s_%s_%s_%s_%s",tmp2,sys_month,sys_date,sys_hour,sys_min,sys_year);
 sprintf(sys_carac,"mkdir %s",root_path);
 system (sys_carac);
 printf("\narchive directory: %s\n\n",root_path);

 sprintf(sys_carac,"%s/%s.READ_ME",root_path,tmp2);
 sys_tmp=fopen(sys_carac,"w");
 fprintf(sys_tmp,"Number of waves: %d,\nFiltering option: %d, \nIB correction option: %d,\nLoading correction option: %d, \nAnalyse type: %d, \n", conf->nbond,conf->filter_type,conf->inv_bar,conf->load_effect,conf->analys_type);

 if(conf->ios_output) fprintf(sys_tmp,".ios.arm file creation\n");
 if(conf->mgr_output) fprintf(sys_tmp,".mgr file creation\n");
 if (conf->fft==1) fprintf(sys_tmp,"FFT computation,\n");
 if (conf->drift==1) fprintf(sys_tmp,"Sea level trend computation\n\n");
 fclose(sys_tmp);

 if(conf->mgr_output)
   {
     sprintf(sys_carac,"%s/%s.mgr",root_path,tmp2);
     conf->mgr_file=fopen(sys_carac,"w");
   }

 sprintf(sys_carac,"%s/%s.sum",root_path,tmp2);
 conf->sum_file=fopen(sys_carac,"w");

 fprintf(conf->sum_file,"#-- HEADER -------------------------------------------\n");
 fprintf(conf->sum_file,"# Column 1 : date in hours referred to\n");
 fprintf(conf->sum_file,"#            CNES date (01-JAN-1950 00:00:00.0)\n");
 fprintf(conf->sum_file,"# Column 2 : sea surface height (in input file units)\n");
 fprintf(conf->sum_file,"# Column 3 : solid tide (in meters)\n");
 fprintf(conf->sum_file,"# Column 4 : barometer (mbar)\n");
 fprintf(conf->sum_file,"# Column 5 : charge tide effect(in meters)\n");
 fprintf(conf->sum_file,"# Column 6 : FES 99 tide prediction(in meters)\n");
 fprintf(conf->sum_file,"# Column 7 : residual(in input file units)\n");
 fprintf(conf->sum_file,"#-- HEADER END ---------------------------------------\n");
 fprintf(conf->sum_file,"Number of time series :\n");
 fprintf(conf->sum_file,"%d\n",conf->nXpoints);

 strcpy(conf->directory_path,root_path);
 sprintf(input,"%s/%s.READ_ME",conf->directory_path,conf->rootname);
 if ( (conf->readme_file=fopen(input,"w")) == NULL) quit("can not create .READ_ME file");


}



/*------------------------------------------------------------------------------*/ 

alloc_copy(int nmes, double **pointeur)

/*------------------------------------------------------------------------------*/ 
{
  if(*pointeur==NULL)
    {
      if ( (*pointeur = (double *) calloc(nmes,sizeof(double)) ) == NULL ) quit("can't allocate copy pointer\n");
    }
      
}/*end*/


/*----------------------------------------------------------------------------*/

void quit(char *message)

/*----------------------------------------------------------------------------*/
{
  printf("%s\nexiting system\n",message);
  exit(-1);
}
